{
    This file is part of the Cheb's Game Engine,
    Copyright (c) 2004-2006 by Anton Rzheshevski (chebmaster@mail.ru),
      and contains a template for dynamic array wrapper classes.

    See the file COPYING.CPS, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}



//    ,  FreePascal 1.06  
//  ,  ,   1.9.2 - , 
//     (Add, Last, SetRect,  ..)
//   ,    ...

// They promise to add generics in 2.10.
// Until then, the implementation is ugly. But it works.



{
  TAOP = array of pointer;
  TAOC = array of cardinal;
  TAOI = array of integer;
  TAOS = array of string;
  TAOB = array of LongBool;
  TAOO = array of TObject;
  T2DAOI = array of array of Integer;
  T2DAOS = array of array of String;
  T2DAOO = array of array of TObject;
}


  TDyna = Class(TObject)
    Constructor Create;
    Destructor Destroy; Override;
    procedure Resize(NewLen: integer);
    procedure Increment;
    procedure Decrement;
    procedure ClearMem; virtual; abstract;
    procedure SetRect(a, b: integer); virtual;
    procedure Save(); virtual; abstract;
    procedure Load(); virtual; abstract;
  Protected
    s, sm, es: integer;
    CurrentMmb: integer;
    function GetSize: integer;
    function GetHigh: integer;
    procedure _Resize(L: integer); virtual; abstract;
    function _ReadDPTR: pointer; virtual; abstract;
  Public
    property High: integer read GetHigh;
    property Length: integer read s write Resize;
    property DPTR:pointer read _ReadDPTR;
  End;
  
  CDyna = Class of TDyna;

{$define typeofit := AnsiString }
{$define type2name := T2DAOS }
{$define type1name := TAOS }
  {$include mo_dyna_2template.h}

{$define typeofit := WideString}
{$define type1name := TAOW}
{$define type2name := T2DAOW}
  {$include mo_dyna_2template.h}

{$define typeofit := float}
{$define type1name := TAOF}
{$define type2name := T2DAOF}
  {$include mo_dyna_2template.h}
  
{$define typeofit := cardinal}
{$define type1name := TAOC}
{$define type2name := T2DAOC}
  {$include mo_dyna_2template.h}

{$define typeofit := integer}
{$define type1name := TAOI}
{$define type2name := T2DAOI}
  {$include mo_dyna_2template.h}

Procedure SafeFree(var o: TObject);

